package com.logicbig.example;

import javax.swing.*;
import java.awt.*;

public class CustomComboRenderer extends DefaultListCellRenderer {
    public static final Color background = new Color(250, 250, 255);
    private static final Color defaultBackground = (Color) UIManager.get("List.background");
    private JLabel searchLabel;

    public CustomComboRenderer(JLabel filterLabel) {
        this.searchLabel = filterLabel;
    }

    @Override
    public Component getListCellRendererComponent(JList<?> list, Object value, int index,
                                                  boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

        Employee emp = (Employee) value;
        if (emp == null) {
            return this;
        }
        String text = getEmployeeDisplayText(emp);
        text = HtmlHighlighter.highlightText(text, searchLabel.getText());
        this.setText(text);
        if (!isSelected) {
            this.setBackground(index % 2 == 0 ? background : defaultBackground);
        }
        return this;
    }

    public static String getEmployeeDisplayText(Employee emp) {
        return String.format("%s [%s]", emp.getName(), emp.getDept());
    }
}